/* Copyright 1997 Sun Microsystems, Inc.  All rights reserved. */

#ifndef trace_h_
#define trace_h_

#pragma ident "@(#)Shade and Spixtools V5.32C, V9 SPARC SunOS"


#include <instr.h>


typedef struct Trace {
	uint32	tr_pc;		/* instruction address */
	Instr	tr_i;		/* instruction text */
	int8	tr_annulled;	/* instruction annulled? */
	int8	tr_taken;	/* branch or trap taken? */
	uint16	tr_ih;		/* ihash() value (opcode) */
	uint32	tr_ea;		/* target address for dcti's.
				 * (NOT fall thru address for untaken branches).
				 * rs1+(rs2 or simm13) for loads, stores, traps.
				 */

#if defined(TR_REGS) || defined(TR_FREGS)
	union ix {
		int32	ii[2];
#ifdef INT64
		int64	x;
#endif
	}
		tr_rs1,		/* rs1 contents before execution */
		tr_rs2,		/* rs2 contents before execution */
		tr_rd;		/* rd contents after execution */
#endif

#ifdef TR_FREGS
	int32	tr_pad;		/* in case no real128 */

	union ixsdq {
		int32	i, ii[2], iiii[4];
#ifdef INT64
		int64	x, xx[2];
#endif
		real32	s, ss[2], ssss[4];
		real64	d, dd[2];
#ifdef REAL128
		real128 q;
#endif
	}
		tr_frs1,	/* frs1 contents before execution */
		tr_frs2,	/* frs2 contents before execution */
		tr_frd;		/* frd contents after execution */
#endif	/* #ifdef TR_FREGS */

#ifdef TR_MORE
	TR_MORE
#endif
} Trace;


#endif	/* #ifndef trace_h_ */
