#include	"defs.h"

#define		LOCAL_HEIGHT	400
#define		LOCAL_WIDTH	300

Frame		SharedBarsFrame;
Canvas		SharedBarsCanvas;
Cms		cms;
XGCValues	gc_val;
XFontStruct	*font;
GC		BarsGc;
Display		*BarsDisplay;
XID		BarsXid;
unsigned long 	*bars_colors;
Window		BarsXwin;
extern	int	WP_COUNTER , RP_COUNTER , TOTAL_WR_ETC_COUNTER;

void		SharedBars_repaintProc();
void		PlayShareBars();

void
ShareMemoryBares()
{
	static char stipple_bits[] =
	{
		0xAA, 0xAA, 0x55, 0x55
	};
	
	static Xv_singlecolor cms_colors[] =
        	{
                	{ 255, 255, 255 },	/* white , 1*/
                	{ 255, 0, 0 },		/* RED ,2 */
                	{ 0, 255, 0 },		/* GREEN , 3 */
                	{ 0, 0, 255 }, 		/* BLUE , 4*/
                	{ 0, 0,   0 }, 		/* BLACK ,5 */
                	{ 250, 130, 80 }, 	/* ORANGE ,6 */
                	{ 30, 230, 250 }, 	/* AQUA ,7 */
                	{ 230, 30, 250 }, 	/* pink ,8  */
                	{ 50, 0,220}, 		/*gray , 9 */
                	{0,255,255}    		/*cyan1 , 10 */
	};

	if (FLAG_FOR_SHARED_BARS == 0 && BLOCK_CreateDrawCanvas_proc_FLAG != 0)
	{
		FLAG_FOR_SHARED_BARS = 1;

		SharedBarsFrame = (Frame)xv_create(NULL , FRAME ,
				FRAME_LABEL,	" READS - WRITES ",
				XV_WIDTH,	LOCAL_WIDTH ,
				XV_HEIGHT,	LOCAL_HEIGHT + 50,
				XV_X,		  0,
				XV_Y,		100,
		NULL);

		cms = xv_create(NULL, CMS,
			CMS_SIZE,       10,
			CMS_TYPE,       XV_STATIC_CMS,
			CMS_COLORS,     cms_colors,
		NULL);

		SharedBarsCanvas = (Canvas)xv_create(SharedBarsFrame,CANVAS,
				CANVAS_X_PAINT_WINDOW,		TRUE,
				XV_VISUAL_CLASS,		PseudoColor,
				WIN_CMS,			cms,
				CANVAS_REPAINT_PROC,		SharedBars_repaintProc,
		NULL);	

		BarsDisplay = (Display *)xv_get(SharedBarsFrame, XV_DISPLAY);
		BarsXid = (XID)xv_get(canvas_paint_window(SharedBarsCanvas), XV_XID);

		if (!(font = XLoadQueryFont(BarsDisplay, "fixed")))
		{
			puts("cannot load fixed font");
			exit(1);
		}
		gc_val.font = font->fid;
		gc_val.stipple = XCreateBitmapFromData(BarsDisplay, 
							BarsXid, stipple_bits, 16, 2);
		BarsGc = XCreateGC(BarsDisplay, BarsXid, GCFont | GCStipple, &gc_val);

		bars_colors = (unsigned long *)xv_get(SharedBarsCanvas, 
							WIN_X_COLOR_INDICES);

		xv_main_loop(SharedBarsFrame);
	}
}

void
SharedBars_repaintProc(canvas,paint_window,dpy,xwin,xrects)
Canvas          canvas;
Xv_Window       paint_window;
Display         *dpy;
Window          xwin;
Xv_xrectlist    *xrects;
{
	READ_WRITE_REFERNCES_ON = 1;
	BarsXwin = xwin;

	/*
	XSetForeground(BarsDisplay, BarsGc, bars_colors[6]);
	XDrawString(BarsDisplay, BarsXid, BarsGc, 5 , 20, "Total Traces", 12);
	XDrawString(BarsDisplay, BarsXid, BarsGc, 100 , 20, "Write Traces", 12);
	XDrawString(BarsDisplay, BarsXid, BarsGc, 180 , 20, "Read Traces", 11);
	*/
}

void
PlayShareBars(writes , reads , total)
int	writes;
int	reads;
int	total;
{
	int	total_bar_height;
	int	writes_height , reads_height;


	fprintf(stderr,"total = %d\n",total);
	total_bar_height = 5 * total / 10000;
	fprintf(stderr,"total_bar_height = %d \n",total_bar_height);

	writes_height = 5 * writes / 10000;
	fprintf(stderr,"writes_height = %d with %d writes\n",writes_height,writes);
	reads_height = 5 * reads / 10000;
	fprintf(stderr,"reads_height = %d with %d reads\n",reads_height, reads);

	if (total_bar_height < LOCAL_HEIGHT)
	{
		XSetForeground(BarsDisplay,BarsGc, bars_colors[2]);
		XFillRectangle(BarsDisplay, BarsXwin, BarsGc, 30 , 400 - total_bar_height + 50, 60 , total_bar_height);

		XSetForeground(BarsDisplay,BarsGc, bars_colors[1]);
		XFillRectangle(BarsDisplay, BarsXwin, BarsGc, 120 , 400 - writes_height+ 50 , 60 , writes_height);

		XSetForeground(BarsDisplay,BarsGc, bars_colors[3]);
		XFillRectangle(BarsDisplay, BarsXwin, BarsGc, 200 , 400 - reads_height + 50, 60 , reads_height);
	}
	else
	{
		XSetForeground(BarsDisplay,BarsGc, bars_colors[0]);
		XFillRectangle(BarsDisplay, BarsXwin, BarsGc, 30 , 0 + 50, 60 , 400);
		TOTAL_WR_ETC_COUNTER = TOTAL_WR_ETC_COUNTER / 2;
		total_bar_height = 5 * TOTAL_WR_ETC_COUNTER / 10000;
		XSetForeground(BarsDisplay,BarsGc, bars_colors[2]);
		XFillRectangle(BarsDisplay, BarsXwin, BarsGc, 30 , 400 - total_bar_height + 50, 60 , total_bar_height);

		XSetForeground(BarsDisplay,BarsGc, bars_colors[0]);
		XFillRectangle(BarsDisplay, BarsXwin, BarsGc, 120 , 400 - writes_height + 50, 60 , writes_height);
		WP_COUNTER = WP_COUNTER / 2;
		writes_height = 5 * WP_COUNTER / 10000;
		XSetForeground(BarsDisplay,BarsGc, bars_colors[1]);
		XFillRectangle(BarsDisplay, BarsXwin, BarsGc, 120 , 400 - writes_height + 50, 60 , writes_height);

		XSetForeground(BarsDisplay,BarsGc, bars_colors[0]);
		XFillRectangle(BarsDisplay, BarsXwin, BarsGc, 200 , 400 - reads_height + 50, 60 , reads_height);
		RP_COUNTER = RP_COUNTER / 2;
		reads_height = 5 * RP_COUNTER / 10000;
		XSetForeground(BarsDisplay,BarsGc, bars_colors[3]);
		XFillRectangle(BarsDisplay, BarsXwin, BarsGc, 200 , 400 - reads_height + 50, 60 , reads_height);
	}
}
