#include "defs.h"
#include "CchParam.h"

struct itimerval        timer;

extern	Frame		Initial;

void			adjust_speed_itlb();
void			adjust_speed_dtlb();
void			adjust_speed_icache();
void			adjust_speed_dcache();
void			adjust_speed_sec_level_cache();
void			ok_function();
int			select_Kb_or_Mb();
int			SetAvailableSize();
int			SetAvailableTLBSize();




void
InitInterface(int choice, char *frame_label)
{
	Frame		frame;
	Panel		panel;
	Panel_item	p_rate,ok_button;
	Panel_item	choice_chain;

	frame = (Frame)xv_create(Initial, FRAME,
				FRAME_LABEL,		frame_label,	
				FRAME_SHOW_FOOTER,	TRUE,
		NULL);

	panel = (Panel)xv_create(frame, PANEL, NULL);

	p_rate = xv_create(panel,  PANEL_SLIDER,
				PANEL_LABEL_STRING,	"size:",
				PANEL_VALUE,		0,
				PANEL_MIN_VALUE,	0,
				PANEL_MAX_VALUE,	2048,
				PANEL_LAYOUT,		PANEL_VERTICAL,
				PANEL_TICKS,		11,
				PANEL_NOTIFY_PROC,	NULL,
		NULL);

	ok_button = xv_create(panel,  PANEL_BUTTON,
				PANEL_LABEL_STRING,	"Ok",
				PANEL_NOTIFY_PROC,	ok_function,
		NULL);

	if (choice != ITLB && choice != DTLB)
	{
		choice_chain = (Panel_item)xv_create(panel, PANEL_CHOICE,
				PANEL_LABEL_STRING,	"Choice:",
				PANEL_CHOICE_STRINGS,	"Kb","Mb",NULL,
				PANEL_NOTIFY_PROC,	select_Kb_or_Mb,
				PANEL_CLIENT_DATA,	frame,
				XV_X,			10,
				XV_Y,			50,
		NULL);
	}
				
	if (choice == ITLB || choice == DTLB)
	{
		xv_set(p_rate, PANEL_VALUE, Initial_TLB_Value, NULL);
		xv_set(p_rate, PANEL_MAX_VALUE, 64, NULL);
		if (choice == ITLB)
			xv_set(p_rate, PANEL_NOTIFY_PROC, adjust_speed_itlb, NULL);
		else
		if (choice == DTLB)
			xv_set(p_rate, PANEL_NOTIFY_PROC, adjust_speed_dtlb, NULL);
		else
			fprintf(stderr,"None fuction is choosen for p_rate ...\n");
	}
	else
	if (choice == ICACHE || choice == DCACHE)
	{
		if (choice == ICACHE)
			xv_set(p_rate, PANEL_VALUE, 5, NULL);
		else
			xv_set(p_rate, PANEL_VALUE, 128, NULL);
		xv_set(choice_chain,PANEL_CHOICE_STRINGS,"Kb","Mb",NULL,NULL);
		if (choice == ICACHE)
			xv_set(p_rate, PANEL_NOTIFY_PROC, adjust_speed_icache, NULL);
		else
		if (choice == DCACHE)
			xv_set(p_rate, PANEL_NOTIFY_PROC, adjust_speed_dcache, NULL);
	}
	else
	{
		if (choice == SECOND_LEVEL_CACHE)
		{
			xv_set(p_rate, PANEL_VALUE, 256, NULL);
			xv_set(choice_chain,PANEL_CHOICE_STRINGS,"Kb","Mb",NULL,NULL);
			xv_set(p_rate, PANEL_NOTIFY_PROC,adjust_speed_sec_level_cache,NULL);
		}
		else
			fprintf(stderr,"None fuction is choosen for p_rate ...2 \n");
	}

	xv_set(frame, FRAME_CMD_PUSHPIN_IN, TRUE, NULL);
	window_fit(panel);
	window_fit(frame);
	xv_main_loop(frame);
}

void
adjust_speed_icache(item , value)
Panel_item	item;
int		value;
{
	Frame   frame;
	int	i;
	
	frame = xv_get(xv_get(item, PANEL_PARENT_PANEL), XV_OWNER);

	i = xv_get(item , PANEL_VALUE);
	InstrCacheSize = SetAvailableSize(item,i);

	timer.it_value.tv_usec =  20 ;
	timer.it_interval.tv_usec = (value + 20) * 1000;
	notify_set_itimer_func(frame,NULL, ITIMER_REAL, &timer, NULL);
}

int
SetAvailableSize(Panel_item item, int i)
{
	int	j;
	
	for (j = 0; j < 11; j++)
		if ((int)(pow(2,j)) >= i)
			break;

	xv_set(item, PANEL_VALUE, (int)(pow(2,j)), NULL);

	return	(int)(pow(2,j));
}

int
SetAvailableTLBSize(Panel_item item, int i)
{
	int	j; 

	j = i;
	if (j > 64)
		j = 64;
	xv_set(item, PANEL_VALUE, j, NULL);

	return j;
}

void
ok_function(item, event)
Panel_item	item;
Event		*event;
{
	Frame 	frame;

	frame = xv_get(xv_get(item, PANEL_PARENT_PANEL), XV_OWNER);
	xv_destroy_safe(frame);
	fprintf(stderr,"The Instr Cache size is choosen to be %d \n",InstrCacheSize);
	fprintf(stderr,"The Data Cache size is choosen to be %d \n",DataCacheSize);
	fprintf(stderr,"The Instr Tlb size is choosen to be %d \n",InstrTlbSize);
	fprintf(stderr,"The Data Tlb size is choosen to be %d \n",DataTlbSize);
}
	

void
adjust_speed_dcache(item , value)
Panel_item	item;
int		value;
{
	Frame   frame;
	int	i;
	
	frame = xv_get(xv_get(item, PANEL_PARENT_PANEL), XV_OWNER);

	i = xv_get(item , PANEL_VALUE);
	DataCacheSize = SetAvailableSize(item,i);

	timer.it_value.tv_usec =  20 ;
	timer.it_interval.tv_usec = (value + 20) * 1000;
	notify_set_itimer_func(frame,NULL, ITIMER_REAL, &timer, NULL);
}

void
adjust_speed_itlb(item , value)
Panel_item	item;
int		value;
{
	Frame   frame;
	int	i;
	
	frame = xv_get(xv_get(item, PANEL_PARENT_PANEL), XV_OWNER);

	i = xv_get(item , PANEL_VALUE);
	InstrTlbSize = SetAvailableTLBSize(item,i);

	timer.it_value.tv_usec =  20 ;
	timer.it_interval.tv_usec = (value + 20) * 1000;
	notify_set_itimer_func(frame,NULL, ITIMER_REAL, &timer, NULL);
}

void
adjust_speed_dtlb(item , value)
Panel_item	item;
int		value;
{
	Frame   frame;
	int	i;
	
	frame = xv_get(xv_get(item, PANEL_PARENT_PANEL), XV_OWNER);

	i = xv_get(item , PANEL_VALUE);
	DataTlbSize = SetAvailableTLBSize(item,i);

	timer.it_value.tv_usec =  20 ;
	timer.it_interval.tv_usec = (value + 20) * 1000;
	notify_set_itimer_func(frame,NULL, ITIMER_REAL, &timer, NULL);
}

void
adjust_speed_sec_level_cache(item , value)
Panel_item	item;
int		value;
{
	Frame   frame;
	int	i;
	
	frame = xv_get(xv_get(item, PANEL_PARENT_PANEL), XV_OWNER);

	i = xv_get(item , PANEL_VALUE);
	SecondLeveCacheSize = SetAvailableSize(item,i);

	timer.it_value.tv_usec =  20 ;
	timer.it_interval.tv_usec = (value + 20) * 1000;
	notify_set_itimer_func(frame,NULL, ITIMER_REAL, &timer, NULL);
}


void
Choose_ITLB_Size()
{
	InitInterface(ITLB, "Choose Instr. TLB Size");
}

void
Choose_DTLB_Size()
{
	InitInterface(DTLB, "Choose Data TLB Size");
}

void
Choose_ICACHE_Size()
{
	InitInterface(ICACHE, "Choose Instr. Cache Size");
}

void
Choose_DCACHE_Size()
{
	InitInterface(DCACHE, "Choose Data Cache Size");
}

void
Choose_SecLevelCache_Size()
{
	InitInterface(SECOND_LEVEL_CACHE,"Choose Second Level Cache Size");
}

int
select_Kb_or_Mb(item, value, event)
Panel_item	item;
int		value;
Event		*event;
{
	char 	buf[32];
	Frame	frame;

	frame = xv_get(item, PANEL_CLIENT_DATA);
	if (event_id(event) == MS_LEFT) 
	{
		sprintf(buf, "\"%s\" selected",
				xv_get(item, PANEL_CHOICE_STRING, panel_get_value(item)));
		xv_set(frame, FRAME_RIGHT_FOOTER, buf, NULL);
		return XV_OK;
	}
	return	XV_ERROR;
}
