#include "defs.h"

Frame		Command_Frame;
Panel		command_panel;
Panel_item	create_text,command_toggle, clear_button;
char		INTERF_COMMAND[128];
char		COMMAND_OPTIONS[40];

void		get_command();
void		cancel_choose();
void		clear_choose();
void		ok_choose();

int		toggle_selected();

int		READ_COMMANDS_FROM_FILE = 0;

extern	Panel_item ChooseCommand, StartB;

extern	void		start_control_comp_panel();
extern	void		Start_Listes();

void
choose_simulation_command()
{

	xv_set(ChooseCommand, PANEL_INACTIVE, TRUE, NULL);

	Command_Frame = (Frame)xv_create(NULL,FRAME,
			FRAME_LABEL,	"Choose Command - Default: ls",
			FRAME_SHOW_FOOTER,	TRUE,
	NULL);

	command_panel = (Panel)xv_create(Command_Frame,PANEL,NULL);
	
	create_text = (Panel_item)xv_create(command_panel, PANEL_TEXT,
			PANEL_LABEL_STRING,	"Command:",
			PANEL_NOTIFY_PROC,	get_command,
			PANEL_LAYOUT,		PANEL_HORIZONTAL,
			PANEL_VALUE_DISPLAY_LENGTH,	20,
			PANEL_VALUE,		"ls",
		NULL);


	clear_button = (Panel_item)xv_create(command_panel,PANEL_BUTTON,
			PANEL_LABEL_STRING,	"Clear",
			PANEL_NOTIFY_PROC,	clear_choose,
		NULL);

	if (READ_COMMANDS_FROM_FILE)
	{
		xv_set(create_text, PANEL_INACTIVE, TRUE, NULL);
		xv_set(clear_button, PANEL_INACTIVE, TRUE, NULL);
	}

	(Panel_item)xv_create(command_panel,PANEL_BUTTON,
			PANEL_LABEL_STRING,	"OK",
			PANEL_NOTIFY_PROC,	ok_choose,
		NULL);

	(Panel_item)xv_create(command_panel,PANEL_BUTTON,
			PANEL_LABEL_STRING,	"Cancel",
			PANEL_NOTIFY_PROC,	cancel_choose,
		NULL);

	window_fit(command_panel);
	window_fit(Command_Frame);
	xv_main_loop(Command_Frame);
}

void
get_command()
{
	char	buf[128];
	char	buf2[128];
	char	options[128];
	char	tmp[128+9];  /* size of buf + size of selected + white space */

	strcpy(buf,(char *)xv_get(create_text, PANEL_VALUE));
	sprintf(tmp,"%s %s\n",buf,"selected");
	xv_set(Command_Frame, FRAME_LEFT_FOOTER, tmp, NULL);
	sscanf(buf,"%s %s\n",buf2,options);
	strcpy(INTERF_COMMAND,buf); /* take the whole command */
	if (strcmp(options,""))
		strcpy(COMMAND_OPTIONS,options);
	else
		strcpy(COMMAND_OPTIONS,"");
}

void
cancel_choose()
{
	xv_destroy_safe(Command_Frame);
}

void
clear_choose()
{
	xv_set(Command_Frame, FRAME_LEFT_FOOTER,"", NULL);
	xv_set(create_text,PANEL_VALUE,"",NULL);
}

void
ok_choose()
{
	xv_set(StartB, PANEL_INACTIVE, FALSE, NULL);
	get_command();
	xv_destroy_safe(Command_Frame);
	return;
}

int
toggle_selected(item, value, event)
Panel_item item;
unsigned value;
Event *event;
{
	char 	buf[32];
	Frame 	frame = xv_get(item, PANEL_CLIENT_DATA);
	int 	i;

	buf[0] = 0;
	if (event_id(event) == MS_LEFT)
	{
		for (i = 0; value; i++, value >>= 1)
			if (value & 1)
				sprintf(buf+strlen(buf), "%s%c ",
					xv_get(item, PANEL_CHOICE_STRING, i),
				(value >> 1)? ',' : ' ');

		if (!READ_COMMANDS_FROM_FILE)
		{
			READ_COMMANDS_FROM_FILE = 1;
			xv_set(command_toggle, PANEL_VALUE, READ_COMMANDS_FROM_FILE, NULL);
			xv_set(create_text, PANEL_INACTIVE, TRUE, NULL);
			xv_set(clear_button, PANEL_INACTIVE, TRUE, NULL);

			fprintf(stderr,"1:READ_COMMANDS_FROM_FILE = %d \n",READ_COMMANDS_FROM_FILE);
			xv_set(frame, FRAME_RIGHT_FOOTER, buf, NULL);
		}
		else
		{
			READ_COMMANDS_FROM_FILE = 0;
			xv_set(create_text, PANEL_INACTIVE, FALSE, NULL);
			xv_set(clear_button, PANEL_INACTIVE, FALSE, NULL);
			xv_set(command_toggle, PANEL_VALUE, READ_COMMANDS_FROM_FILE, NULL);
			fprintf(stderr,"2:READ_COMMANDS_FROM_FILE = %d \n",READ_COMMANDS_FROM_FILE);
			xv_set(frame, FRAME_RIGHT_FOOTER, "Give you command", NULL);
		}
		return XV_OK;
	}
	return XV_ERROR;
}

