#include "dtb.h"

extern	int	DataTlbSize;
extern	int	InstrTlbSize;

long	DtbReference();
long	InstrDtbReference();

void	init_dtb_structures();

/******************** DTB starts here **************************************************/
extern	int	HOW_MANY;

long
DtbReference(address,count)
long	address;
int	count;
{
	long 	page = address >> PAGESHIFT;
  	int 	i = array_pageMap[count][page & (MAPSIZE-1)];

  	if (array_dtb[count][i] != page) 
	{
    		for (i = 0; i < DTBSIZE[count]; i++) 
		{
      			if (array_dtb[count][i] == page) 
			{
				array_pageMap[count][page & (MAPSIZE - 1)] = i;
				break;
      			}
    		}
  	}

  	if (i >= DTBSIZE[count]) 
	{
		int	tmp_i;

    		array_misses[count]++;
    		array_dtb[count][nextMapping[count]] = page;
    		array_pageMap[count][page & (MAPSIZE-1)] = nextMapping[count];
		tmp_i = nextMapping[count];
    		nextMapping[count] = NEXTDTB(nextMapping[count],DTBSIZE[count]);
		return	(tmp_i*PAGESIZE);
  	} 
	else 
	{
    		array_hits[count]++;
    		if (nextMapping[count] == i) 
		{
      			nextMapping[count] = NEXTDTB(i,DTBSIZE[count]);
    		}
		return (i*PAGESIZE);
  	}
}

void 
DtbPrintResults()
{
  	FILE 	*file;
	int	count;

  	file = fopen("/tmp/dtb.out","w");
	if (!file)
		return;
  	assert(file != NULL);

/*
  	fprintf(file,"DTB hits:       %12ld\n",hits);
  	fprintf(file,"DTB Misses:     %12ld\n",misses);
  	fprintf(file,"DTB references: %12ld\n",hits+misses);
  	fprintf(file,"DTB Miss Rate:      %12.4lf\n",(double) misses/(hits+misses));

  	fprintf(file,"INSTRDTB hits:       %12ld\n",InstrHits);
  	fprintf(file,"INSTRDTB Misses:     %12ld\n",InstrMisses);
  	fprintf(file,"INSTRDTB references: %12ld\n",InstrHits+InstrMisses);
  	fprintf(file,"INSTR Miss Rate:      %12.4lf\n",(double) InstrMisses/(InstrHits+InstrMisses));
*/
	
	for (count = 0; count < HOW_MANY + 1; count++)
	{
		fprintf(file,"DTB array_hits[%d]:       %12ld\n",count, array_hits[count]);
		fprintf(file,"DTB array_misses[%d]: 	%12ld\n",count, array_misses[count]);

		fprintf(file,"INSTR array_hits[%d]:       %12ld\n",count, array_InstrHits[count]);
		fprintf(file,"INSTR array_misses[%d]:     %12ld\n",count, array_InstrMisses[count]);
	}

  	fclose(file);
}

long 
InstrDtbReference(address,count)
long	address;
int	count;
{
	long 	page = address >> PAGESHIFT;
  	int 	i = array_InstrpageMap[count][page & (MAPSIZE-1)];

  	if (array_InstrDtb[count][i] != page) 
	{
    		for (i = 0; i < InstrDTBSIZE[count]; i++) 
		{
      			if (array_InstrDtb[count][i] == page) 
			{
				array_InstrpageMap[count][page & (MAPSIZE - 1)] = i;
				break;
      			}
    		}
  	}
  	if (i >= InstrDTBSIZE[count]) 
	{
		int	tmp_i;

    		array_InstrMisses[count]++;
    		array_InstrDtb[count][InstrnextMapping[count]] = page;
    		array_InstrpageMap[count][page & (MAPSIZE-1)] = InstrnextMapping[count];
		tmp_i = InstrnextMapping[count];
    		InstrnextMapping[count] = NEXTDTB(InstrnextMapping[count],InstrDTBSIZE[count]);
		return	(tmp_i*PAGESIZE);
  	} 
	else 
	{
    		array_InstrHits[count]++;
    		if (InstrnextMapping[count] == i) 
		{
      			InstrnextMapping[count] = NEXTDTB(i,InstrDTBSIZE[count]);
    		}
		return (i*PAGESIZE);
  	}
}

void
init_Tlb()
{
	int	count;

	if (!HOW_MANY)
	{
		DTBSIZE[0] = DataTlbSize;
		InstrDTBSIZE[0] = InstrTlbSize;
	}

	array_dtb = (long **)malloc((AT_MORE+1)*sizeof(long *));
	for (count = 0; count < AT_MORE + 1; count++)
		array_dtb[count] = (long *)malloc(sizeof(long)*DTBSIZE[count]);

	array_pageMap = (int **)malloc((AT_MORE+1)*sizeof(int *));
	for (count = 0; count < AT_MORE + 1; count++)
		array_pageMap[count] = (int *)malloc(MAPSIZE*sizeof(int));

	array_hits = (long *)malloc((AT_MORE+1)*sizeof(long));
	array_misses = (long *)malloc((AT_MORE+1)*sizeof(long));

	nextMapping = (int *)malloc((AT_MORE+1)*sizeof(int));

	/************** Istr declarations starts here ... ************/

	array_InstrDtb = (long **)malloc((AT_MORE+1)*sizeof(long *));
	for (count = 0; count < AT_MORE + 1; count++)
		array_InstrDtb[count] = (long *)malloc(InstrDTBSIZE[count]*sizeof(long));

	array_InstrpageMap = (int **)malloc((AT_MORE+1)*sizeof(int *));
	for (count = 0; count < AT_MORE + 1; count++)
		array_InstrpageMap[count] = (int *)malloc(MAPSIZE*sizeof(int));

	array_InstrHits = (long *)malloc((AT_MORE+1)*sizeof(long));
	array_InstrMisses = (long *)malloc((AT_MORE+1)*sizeof(long));

	InstrnextMapping = (int *)malloc((AT_MORE+1)*sizeof(int));
	/************* Some Initializations ... **********************/

	init_dtb_structures();
}

void
init_dtb_structures()
{
	int	count, j;

	for (count = 0; count < AT_MORE + 1; count++)
	{
		nextMapping[count] = 0;
		InstrnextMapping[count] = 0;
	}

	for (count = 0; count < AT_MORE + 1; count++)
		for (j = 0; j < DTBSIZE[count]; j++)
			array_dtb[count][j] = 0;	

	for (count = 0; count < AT_MORE + 1; count++)
		for (j = 0; j < MAPSIZE; j++)
			array_pageMap[count][j] = 0;

	for (count = 0; count < AT_MORE + 1; count++)
	{
		array_hits[count] = 0;	
		array_misses[count] = 0;
		array_InstrHits[count] = 0;
		array_InstrMisses[count] = 0;
	}

	for (count = 0; count < AT_MORE + 1; count++)
		for (j = 0; j < InstrDTBSIZE[count]; j++)
			array_InstrDtb[count][j] = 0;

	for (count = 0; count < AT_MORE + 1; count++)
		for (j = 0; j < MAPSIZE; j++)
			array_InstrpageMap[count][j] = 0;

	

}

/********************** Dtb finishes here **********************************/

