#include "SimParams.h"
#include "Tcp.h"
#include <sys/types.h>
#include <signal.h>

#ifndef SIGUSR2
#define SIGUSR2 31
#endif

int 	servershutdown();
int 	create_socket();
int 	accept_connection();
char 	*actions();
char	*get_socket_connection();
char	*accept_connection_and_use_socket();

int 	socket_descriptor;
int	connection;

extern	int	HOW_MANY;
extern	int	READ_COMMANDS_FROM_FILE;

/*
main()
{ 
	get_socket_connection();
}
*/

char *
get_socket_connection()
{
	char	*buf;

	socket_descriptor = create_socket(PORT);

/*
	fprintf(stderr,"A socket has just been created .\n");
	for (;;)
*/

    kill(getppid(), SIGUSR2);

	buf = accept_connection_and_use_socket(1);
	return buf;
}

char	*
accept_connection_and_use_socket(flag)
int	flag;
{
	char	*buf;

	while ((connection=accept_connection(socket_descriptor)) == -1)
		;		/* skip unsuccesful accept attempts */
/*
	fprintf(stderr,"Connection has been accepted ...\n");
*/
	if (flag)
		buf = actions(connection);
	/*close(connection);*/
	return	buf;
}

int
servershutdown()
{
	fprintf(stdout, "\n");
/*
	fprintf(stdout, "(Server) : closing port\n");
*/
	close(socket_descriptor);
/*
	fprintf(stdout, "(Server) : terminating\n");
	fprintf(stdout, "\n");
*/
	kill(getpid(), SIGKILL);
	exit(0);
}

int
create_socket(port)
u_short	port;
{
	char	hostname[HOSTNAMELEN+1];
	int	socket_descriptor;
    	struct sockaddr_in sa;
	struct hostent *host;

	gethostname(hostname, HOSTNAMELEN);
	if ((host = gethostbyname(hostname)) == NULL)
	{
		fprintf(stderr, "%s ---> no information found for host %s\n",
				"(SERVER)", hostname);
		exit(1);
	}

	/* do some binding here...  */
    	bzero(&sa, sizeof(struct sockaddr_in));	/* clear address info struct */
    	sa.sin_family = host->h_addrtype;	/* this is our host address */
    	sa.sin_port = htons((u_short)port);	/* this is our port number */

	if ((socket_descriptor = socket(AF_INET, SOCK_STREAM, 0)) < 0)
	{
		perror("(SERVER) ---> on socket creation");
		servershutdown();
	}

    	if (bind(socket_descriptor, &sa, sizeof(sa)) != 0)
	{
		perror("(SERVER) ---> on binding");
		servershutdown();
	}
	if (listen(socket_descriptor, 0) == -1)	/* support 5 pending calls */
	{
		perror("(SERVER) ---> listen");
		servershutdown();
	}
	return socket_descriptor;
}

int
accept_connection(socket_descriptor)
int	socket_descriptor;
{
	int	fromlen = sizeof(struct sockaddr_in);	/* init. as reuired */
	int	new_socket_descriptor;
	struct sockaddr_in from;

	getsockname(socket_descriptor, &from, &fromlen); /* get correct value */

	new_socket_descriptor = accept(socket_descriptor,
				       (struct sockaddr *)&from,
				       &fromlen);
	if (new_socket_descriptor < 0)
	{
		if (errno == EINTR)	/* just do it again */
			return(accept_connection(socket_descriptor));
		perror("(SFTP_SERVER) ---> on accept");
		return -1;
	}
    	return(new_socket_descriptor);
}

char *
actions(s_id)
int	s_id;
{
  char			inbuf[MSGLEN+1], outbuf[MSGLEN+1];
  int			nread, nwrite, connection_keep = 1;
  Msg_test 		tmp;
  int			count;
  SimultParamsStruct	Simult;
  int			pid;

  pid = getpid();
/*
  fprintf(stderr,"Process id is %d \n",pid);
	
  fprintf(stderr,"In action ...\n");
*/
  tmp.pid = pid;
  tmp.a1 = 1001;
  tmp.a2 = -128;
  nwrite = write(s_id, &tmp,sizeof(Msg_test));

  read(s_id, &tmp,sizeof(Msg_test));

  InstrCacheSize = tmp.InstrCacheSize;
  DataCacheSize = tmp.DataCacheSize;
  InstrTlbSize = tmp.InstrTlbSize;
  DataTlbSize = tmp.DataTlbSize;
  SecondLeveCacheSize = tmp.SecondLeveCacheSize;
  HOW_MANY = tmp.how_many;
  READ_COMMANDS_FROM_FILE = tmp.read_from_file;

/********************
  fprintf(stderr,"a1 is %d , a2 is %d \n",tmp.a1, tmp.a2);
  fprintf(stderr,"command is %s \n",tmp.command);
  fprintf(stderr,"Parameters: InstrCacheSize = %d , DataCacheSize = %d \n",InstrCacheSize,DataCacheSize);
  fprintf(stderr,"\tInstrTlbSize = %d , DataTlbSize = %d \n",InstrTlbSize,DataTlbSize);
  fprintf(stderr,"\tSecondLeveCacheSize = %d \n",SecondLeveCacheSize);
********************/

  read(s_id,&Simult,sizeof(SimultParamsStruct));
/**************
  fprintf(stderr,"HOW_MANY is %d \n",HOW_MANY);
  fprintf(stderr,"Total Simultaneus Runs are HOW_MANY + %d = %d \n",1,HOW_MANY + 1);
***************/

  for (count = 0; count < 5; count++) {
    InstrTLBParams[count] = Simult.InstrTLBParams[count];
/************
    fprintf(stderr,"InstrTLBParams[%d] = %d \n",count,InstrTLBParams[count]);
*************/
    DataTLBParams[count] = Simult.DataTLBParams[count];
/************
    fprintf(stderr,"DataTLBParams[%d] = %d \n",count,DataTLBParams[count]);
*************/
    InstrCacheParams[count] = Simult.InstrCacheParams[count];
/************
    fprintf(stderr,"InstrCacheParams[%d] = %d \n",count,InstrCacheParams[count]);
*************/
    DataCacheParams[count] = Simult.DataCacheParams[count];
/************
    fprintf(stderr,"DataCacheParams[%d] = %d \n",count,DataCacheParams[count]);
*************/
    SecLevelCacheParams[count] = Simult.SecLevelCacheParams[count];
/************
    fprintf(stderr,"SecLevelCacheParams[%d] = %d \n",count,SecLevelCacheParams[count]);
*************/

    strcpy(InstrTLBWhat[count],Simult.InstrTLBWhat[count]);
/************
    fprintf(stderr,"InstrTLBWhat[%d] = %s\n",count,InstrTLBWhat[count]);
*************/
    strcpy(DataTLBWhat[count],Simult.DataTLBWhat[count]);
/************
    fprintf(stderr,"DataTLBWhat[%d] = %s \n",count,DataTLBWhat[count]);
*************/
    strcpy(InstrCacheWhat[count],Simult.InstrCacheWhat[count]);
/************
    fprintf(stderr,"InstrCacheWhat[%d] = %s \n",count,InstrCacheWhat[count]);
*************/
    strcpy(DataCacheWhat[count],Simult.DataCacheWhat[count]);
/************
    fprintf(stderr,"DataCacheWhat[%d] = %s \n",count,DataCacheWhat[count]);
*************/
    strcpy(SecLevelCacheWhat[count],Simult.SecLevelCacheWhat[count]);
/************
    fprintf(stderr,"SecLevelCacheWhat[%d] = %s \n",count,SecLevelCacheWhat[count]);
*************/
  }

  return tmp.command;
}

